<?php


namespace Flat101\DnsPrefetch\Helper;


class Data extends \Magento\Framework\App\Helper\AbstractHelper
{
    const XML_PATH_DNSPREF_ENABLED   = 'flat101_dnsprefetch/general/enabled';
    const XML_PATH_DNSPREF_RESOURCES = 'flat101_dnsprefetch/general/resource_dns';

    /**
     * @return array
     * @throws \Zend_Json_Exception
     */
    public function getResourceDns(): array
    {
        $result = [];
        $resources  = \Zend_Json::decode($this->scopeConfig->getValue(self::XML_PATH_DNSPREF_RESOURCES));
        foreach ($resources as $item) {
            $result[] = $item['resource_dns'];
        }

        return $result;

    }

    /**
     * Check if Google Optimize module is enabled
     *
     * @return bool
     */
    public function isEnabled(): bool
    {
        return $this->scopeConfig->isSetFlag(self::XML_PATH_DNSPREF_ENABLED);
    }
}
