<?php


namespace Flat101\DnsPrefetch\Observer\Framework\View\Layout;


use Magento\Framework\Event\Observer;
use Magento\Framework\View\Page\Config as PageConfig;

class Builder implements \Magento\Framework\Event\ObserverInterface
{
    /** @var PageConfig $pageConfig */
    private $pageConfig;

    /** @var \Flat101\DnsPrefetch\Helper\Data $helperData */
    private $helperData;

    /**
     * Builder constructor.
     *
     * @param PageConfig $pageConfig
     * @param \Flat101\DnsPrefetch\Helper\Data $helperData
     */
    public function __construct(
        PageConfig $pageConfig,
        \Flat101\DnsPrefetch\Helper\Data $helperData
    ) {
        $this->pageConfig = $pageConfig;
        $this->helperData = $helperData;
    }


    /**
     * @inheritDoc
     */
    public function execute(Observer $observer)
    {
        if (!$this->helperData->isEnabled()) {
            return $this;
        }
        foreach ($this->helperData->getResourceDns() as $resource) {
            $this->pageConfig->addRemotePageAsset(
                $resource,
                'link_rel',
                [
                    'attributes' => [ 'rel' => 'dns-prefetch' ]
                ]
            );
        }

        return $this;
    }
}
